#if !defined(AFX_FileDropListCtrl_H__55F59001_AD5F_11D3_9DA4_0008C711C6B6__INCLUDED_)
#define AFX_FileDropListCtrl_H__55F59001_AD5F_11D3_9DA4_0008C711C6B6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CFileDropListCtrl : public CListCtrl
{
public:
	CFileDropListCtrl();
	virtual ~CFileDropListCtrl();

	enum DLDropFlags
	{
		DL_ACCEPT_FILES =       0x01,
		DL_ACCEPT_FOLDERS =		0x02,
		DL_ALLOW_DUPLICATES =	0x04,
		DL_FOLDER_TYPE =		0x10,
		DL_FILE_TYPE =			0x20
	};

	BOOL SetDropMode(const CFileDropListCtrl::UINT& iMask);
	UINT GetDropMode() const
	{
		return m_dropMode;
	};

protected:
	//{{AFX_MSG(CFileDropListCtrl)
	afx_msg void OnDropFiles(HDROP dropInfo);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	virtual int InsertPathname(const CString& csFilename);

private:
	UINT iMask;
	UINT m_dropMode;
	BOOL m_bMustUninitOLE;

	CString ExpandShortcut(CString& csFilename) const;
	BOOL ValidatePathname(const CString& csPathname, UINT& iPathType) const;

	CFileDropListCtrl& operator=(const CFileDropListCtrl& x);
	CFileDropListCtrl(const CFileDropListCtrl& x);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FileDropListCtrl_H__55F59001_AD5F_11D3_9DA4_0008C711C6B6__INCLUDED_)
